package xyz.lychee.lagfixer.libs.adventure.platform.bukkit;

import java.lang.invoke.MethodHandle;
import java.lang.reflect.Field;
import java.lang.reflect.Method;
import java.lang.reflect.Modifier;
import java.util.Optional;
import xyz.lychee.lagfixer.libs.adventure.platform.facet.Knob;
import xyz.lychee.lagfixer.libs.annotations.Nullable;

final class CraftBukkitAccess {
   static final @Nullable Class<?> CLASS_CHAT_COMPONENT = MinecraftReflection.findClass(MinecraftReflection.findNmsClassName("IChatBaseComponent"), MinecraftReflection.findMcClassName("network.chat.IChatBaseComponent"), MinecraftReflection.findMcClassName("network.chat.Component"));
   static final @Nullable Class<?> CLASS_REGISTRY = MinecraftReflection.findClass(MinecraftReflection.findNmsClassName("IRegistry"), MinecraftReflection.findMcClassName("core.IRegistry"), MinecraftReflection.findMcClassName("core.Registry"));
   static final @Nullable Class<?> CLASS_SERVER_LEVEL = MinecraftReflection.findClass(MinecraftReflection.findMcClassName("server.level.WorldServer"), MinecraftReflection.findMcClassName("server.level.ServerLevel"));
   static final @Nullable Class<?> CLASS_LEVEL = MinecraftReflection.findClass(MinecraftReflection.findMcClassName("world.level.World"), MinecraftReflection.findMcClassName("world.level.Level"));
   static final @Nullable Class<?> CLASS_REGISTRY_ACCESS = MinecraftReflection.findClass(MinecraftReflection.findMcClassName("core.IRegistryCustom"), MinecraftReflection.findMcClassName("core.RegistryAccess"));
   static final @Nullable Class<?> CLASS_RESOURCE_KEY = MinecraftReflection.findClass(MinecraftReflection.findMcClassName("resources.ResourceKey"));
   static final @Nullable Class<?> CLASS_RESOURCE_LOCATION = MinecraftReflection.findClass(MinecraftReflection.findNmsClassName("MinecraftKey"), MinecraftReflection.findMcClassName("resources.MinecraftKey"), MinecraftReflection.findMcClassName("resources.ResourceLocation"));
   static final @Nullable Class<?> CLASS_NMS_ENTITY = MinecraftReflection.findClass(MinecraftReflection.findNmsClassName("Entity"), MinecraftReflection.findMcClassName("world.entity.Entity"));
   static final @Nullable Class<?> CLASS_BUILT_IN_REGISTRIES = MinecraftReflection.findClass(MinecraftReflection.findMcClassName("core.registries.BuiltInRegistries"));
   static final @Nullable Class<?> CLASS_HOLDER = MinecraftReflection.findClass(MinecraftReflection.findMcClassName("core.Holder"));
   static final @Nullable Class<?> CLASS_WRITABLE_REGISTRY = MinecraftReflection.findClass(MinecraftReflection.findNmsClassName("IRegistryWritable"), MinecraftReflection.findMcClassName("core.IRegistryWritable"), MinecraftReflection.findMcClassName("core.WritableRegistry"));

   private CraftBukkitAccess() {
   }

   static final class EntitySound_1_19_3 {
      static final @Nullable MethodHandle NEW_RESOURCE_LOCATION;
      static final @Nullable MethodHandle REGISTRY_GET_OPTIONAL;
      static final @Nullable MethodHandle REGISTRY_WRAP_AS_HOLDER;
      static final @Nullable MethodHandle SOUND_EVENT_CREATE_VARIABLE_RANGE;
      static final @Nullable MethodHandle NEW_CLIENTBOUND_ENTITY_SOUND;
      static final @Nullable Object SOUND_EVENT_REGISTRY;

      private EntitySound_1_19_3() {
      }

      static boolean isSupported() {
         return NEW_CLIENTBOUND_ENTITY_SOUND != null && SOUND_EVENT_REGISTRY != null && NEW_RESOURCE_LOCATION != null && REGISTRY_GET_OPTIONAL != null && REGISTRY_WRAP_AS_HOLDER != null && SOUND_EVENT_CREATE_VARIABLE_RANGE != null;
      }

      static {
         NEW_RESOURCE_LOCATION = MinecraftReflection.findConstructor(CraftBukkitAccess.CLASS_RESOURCE_LOCATION, String.class, String.class);
         REGISTRY_GET_OPTIONAL = MinecraftReflection.searchMethod(CraftBukkitAccess.CLASS_REGISTRY, 1, "getOptional", Optional.class, CraftBukkitAccess.CLASS_RESOURCE_LOCATION);
         REGISTRY_WRAP_AS_HOLDER = MinecraftReflection.searchMethod(CraftBukkitAccess.CLASS_REGISTRY, 1, "wrapAsHolder", CraftBukkitAccess.CLASS_HOLDER, Object.class);
         SOUND_EVENT_CREATE_VARIABLE_RANGE = MinecraftReflection.searchMethod(CraftBukkitAccess.EntitySound.CLASS_SOUND_EVENT, 9, "createVariableRangeEvent", CraftBukkitAccess.EntitySound.CLASS_SOUND_EVENT, CraftBukkitAccess.CLASS_RESOURCE_LOCATION);
         NEW_CLIENTBOUND_ENTITY_SOUND = MinecraftReflection.findConstructor(CraftBukkitAccess.EntitySound.CLASS_CLIENTBOUND_ENTITY_SOUND, CraftBukkitAccess.CLASS_HOLDER, CraftBukkitAccess.EntitySound.CLASS_SOUND_SOURCE, CraftBukkitAccess.CLASS_NMS_ENTITY, Float.TYPE, Float.TYPE, Long.TYPE);
         Object soundEventRegistry = null;

         try {
            Field soundEventRegistryField = MinecraftReflection.findField(CraftBukkitAccess.CLASS_BUILT_IN_REGISTRIES, CraftBukkitAccess.CLASS_REGISTRY, "SOUND_EVENT");
            if (soundEventRegistryField != null) {
               soundEventRegistry = soundEventRegistryField.get((Object)null);
            } else if (CraftBukkitAccess.CLASS_BUILT_IN_REGISTRIES != null && REGISTRY_GET_OPTIONAL != null && NEW_RESOURCE_LOCATION != null) {
               Object rootRegistry = null;
               Field[] var3 = CraftBukkitAccess.CLASS_BUILT_IN_REGISTRIES.getDeclaredFields();
               int var4 = var3.length;

               for(int var5 = 0; var5 < var4; ++var5) {
                  Field field = var3[var5];
                  int mask = true;
                  if ((field.getModifiers() & 26) == 26 && field.getType().equals(CraftBukkitAccess.CLASS_WRITABLE_REGISTRY)) {
                     field.setAccessible(true);
                     rootRegistry = field.get((Object)null);
                     break;
                  }
               }

               if (rootRegistry != null) {
                  soundEventRegistry = REGISTRY_GET_OPTIONAL.invoke(rootRegistry, NEW_RESOURCE_LOCATION.invoke("minecraft", "sound_event")).orElse((Object)null);
               }
            }
         } catch (Throwable var8) {
            Throwable error = var8;
            Knob.logError(error, "Failed to initialize EntitySound_1_19_3 CraftBukkit facet", new Object[0]);
         }

         SOUND_EVENT_REGISTRY = soundEventRegistry;
      }
   }

   static final class EntitySound {
      static final @Nullable Class<?> CLASS_CLIENTBOUND_ENTITY_SOUND = MinecraftReflection.findClass(MinecraftReflection.findNmsClassName("PacketPlayOutEntitySound"), MinecraftReflection.findMcClassName("network.protocol.game.PacketPlayOutEntitySound"), MinecraftReflection.findMcClassName("network.protocol.game.ClientboundSoundEntityPacket"));
      static final @Nullable Class<?> CLASS_SOUND_SOURCE = MinecraftReflection.findClass(MinecraftReflection.findNmsClassName("SoundCategory"), MinecraftReflection.findMcClassName("sounds.SoundCategory"), MinecraftReflection.findMcClassName("sounds.SoundSource"));
      static final @Nullable Class<?> CLASS_SOUND_EVENT = MinecraftReflection.findClass(MinecraftReflection.findNmsClassName("SoundEffect"), MinecraftReflection.findMcClassName("sounds.SoundEffect"), MinecraftReflection.findMcClassName("sounds.SoundEvent"));
      static final @Nullable MethodHandle SOUND_SOURCE_GET_NAME;

      private EntitySound() {
      }

      static boolean isSupported() {
         return SOUND_SOURCE_GET_NAME != null;
      }

      static {
         MethodHandle soundSourceGetName = null;
         if (CLASS_SOUND_SOURCE != null) {
            Method[] var1 = CLASS_SOUND_SOURCE.getDeclaredMethods();
            int var2 = var1.length;

            for(int var3 = 0; var3 < var2; ++var3) {
               Method method = var1[var3];
               if (method.getReturnType().equals(String.class) && method.getParameterCount() == 0 && !"name".equals(method.getName()) && Modifier.isPublic(method.getModifiers())) {
                  try {
                     soundSourceGetName = MinecraftReflection.lookup().unreflect(method);
                  } catch (IllegalAccessException var6) {
                  }
                  break;
               }
            }
         }

         SOUND_SOURCE_GET_NAME = soundSourceGetName;
      }
   }

   static final class Chat1_19_3 {
      static final @Nullable MethodHandle NEW_RESOURCE_LOCATION;
      static final @Nullable MethodHandle RESOURCE_KEY_CREATE;
      static final @Nullable MethodHandle SERVER_PLAYER_GET_LEVEL;
      static final @Nullable MethodHandle SERVER_LEVEL_GET_REGISTRY_ACCESS;
      static final @Nullable MethodHandle LEVEL_GET_REGISTRY_ACCESS;
      static final @Nullable MethodHandle ACTUAL_GET_REGISTRY_ACCESS;
      static final @Nullable MethodHandle REGISTRY_ACCESS_GET_REGISTRY_OPTIONAL;
      static final @Nullable MethodHandle REGISTRY_GET_OPTIONAL;
      static final @Nullable MethodHandle REGISTRY_GET_ID;
      static final @Nullable MethodHandle DISGUISED_CHAT_PACKET_CONSTRUCTOR;
      static final @Nullable MethodHandle CHAT_TYPE_BOUND_NETWORK_CONSTRUCTOR;
      static final Object CHAT_TYPE_RESOURCE_KEY;

      private Chat1_19_3() {
      }

      static boolean isSupported() {
         return ACTUAL_GET_REGISTRY_ACCESS != null && REGISTRY_ACCESS_GET_REGISTRY_OPTIONAL != null && REGISTRY_GET_OPTIONAL != null && CHAT_TYPE_BOUND_NETWORK_CONSTRUCTOR != null && DISGUISED_CHAT_PACKET_CONSTRUCTOR != null && CHAT_TYPE_RESOURCE_KEY != null;
      }

      static {
         NEW_RESOURCE_LOCATION = MinecraftReflection.findConstructor(CraftBukkitAccess.CLASS_RESOURCE_LOCATION, String.class, String.class);
         RESOURCE_KEY_CREATE = MinecraftReflection.searchMethod(CraftBukkitAccess.CLASS_RESOURCE_KEY, 9, "create", CraftBukkitAccess.CLASS_RESOURCE_KEY, CraftBukkitAccess.CLASS_RESOURCE_KEY, CraftBukkitAccess.CLASS_RESOURCE_LOCATION);
         SERVER_PLAYER_GET_LEVEL = MinecraftReflection.searchMethod(CraftBukkitFacet.CRAFT_PLAYER_GET_HANDLE.type().returnType(), 1, "getLevel", CraftBukkitAccess.CLASS_SERVER_LEVEL);
         SERVER_LEVEL_GET_REGISTRY_ACCESS = MinecraftReflection.searchMethod(CraftBukkitAccess.CLASS_SERVER_LEVEL, 1, "registryAccess", CraftBukkitAccess.CLASS_REGISTRY_ACCESS);
         LEVEL_GET_REGISTRY_ACCESS = MinecraftReflection.searchMethod(CraftBukkitAccess.CLASS_LEVEL, 1, "registryAccess", CraftBukkitAccess.CLASS_REGISTRY_ACCESS);
         ACTUAL_GET_REGISTRY_ACCESS = SERVER_LEVEL_GET_REGISTRY_ACCESS == null ? LEVEL_GET_REGISTRY_ACCESS : SERVER_LEVEL_GET_REGISTRY_ACCESS;
         REGISTRY_ACCESS_GET_REGISTRY_OPTIONAL = MinecraftReflection.searchMethod(CraftBukkitAccess.CLASS_REGISTRY_ACCESS, 1, "registry", Optional.class, CraftBukkitAccess.CLASS_RESOURCE_KEY);
         REGISTRY_GET_OPTIONAL = MinecraftReflection.searchMethod(CraftBukkitAccess.CLASS_REGISTRY, 1, "getOptional", Optional.class, CraftBukkitAccess.CLASS_RESOURCE_LOCATION);
         REGISTRY_GET_ID = MinecraftReflection.searchMethod(CraftBukkitAccess.CLASS_REGISTRY, 1, "getId", Integer.TYPE, Object.class);
         MethodHandle boundNetworkConstructor = null;
         MethodHandle disguisedChatPacketConstructor = null;
         Object chatTypeResourceKey = null;

         try {
            Class<?> classChatTypeBoundNetwork = MinecraftReflection.findClass(MinecraftReflection.findMcClassName("network.chat.ChatType$BoundNetwork"));
            Class disguisedChatPacketClass;
            if (classChatTypeBoundNetwork == null) {
               disguisedChatPacketClass = MinecraftReflection.findClass(MinecraftReflection.findMcClassName("network.chat.ChatMessageType"));
               if (disguisedChatPacketClass != null) {
                  Class[] var5 = disguisedChatPacketClass.getClasses();
                  int var6 = var5.length;

                  for(int var7 = 0; var7 < var6; ++var7) {
                     Class<?> childClass = var5[var7];
                     boundNetworkConstructor = MinecraftReflection.findConstructor(childClass, Integer.TYPE, CraftBukkitAccess.CLASS_CHAT_COMPONENT, CraftBukkitAccess.CLASS_CHAT_COMPONENT);
                     if (boundNetworkConstructor != null) {
                        classChatTypeBoundNetwork = childClass;
                        break;
                     }
                  }
               }
            }

            disguisedChatPacketClass = MinecraftReflection.findClass(MinecraftReflection.findMcClassName("network.protocol.game.ClientboundDisguisedChatPacket"));
            if (disguisedChatPacketClass != null && classChatTypeBoundNetwork != null) {
               disguisedChatPacketConstructor = MinecraftReflection.findConstructor(disguisedChatPacketClass, CraftBukkitAccess.CLASS_CHAT_COMPONENT, classChatTypeBoundNetwork);
            }

            if (NEW_RESOURCE_LOCATION != null && RESOURCE_KEY_CREATE != null) {
               MethodHandle createRegistryKey = MinecraftReflection.searchMethod(CraftBukkitAccess.CLASS_RESOURCE_KEY, 9, "createRegistryKey", CraftBukkitAccess.CLASS_RESOURCE_KEY, CraftBukkitAccess.CLASS_RESOURCE_LOCATION);
               if (createRegistryKey != null) {
                  chatTypeResourceKey = createRegistryKey.invoke(NEW_RESOURCE_LOCATION.invoke("minecraft", "chat_type"));
               }
            }
         } catch (Throwable var9) {
            Throwable error = var9;
            Knob.logError(error, "Failed to initialize 1.19.3 chat support", new Object[0]);
         }

         DISGUISED_CHAT_PACKET_CONSTRUCTOR = disguisedChatPacketConstructor;
         CHAT_TYPE_BOUND_NETWORK_CONSTRUCTOR = boundNetworkConstructor;
         CHAT_TYPE_RESOURCE_KEY = chatTypeResourceKey;
      }
   }
}
